Bug 115610 - Add Support for mspace element
: Add Support for mspace element
Status: RESOLVED FIXED
: WebKit
MathML
: 528+ (Nightly build)
: Unspecified Unspecified
: P2 Normal
Assigned To:
: http://www.w3.org/TR/MathML/chapter3....
: WebExposed
: 118053
: 84019 99623 115583
  Show dependency treegraph
 
Reported: 2013-05-05 01:23 PST by
Modified: 2014-03-10 12:25 PST (History)


Attachments
WIP Patch (9.00 KB, patch)
2013-05-16 15:02 PST, Frédéric Wang
no flags Review Patch | Details | Formatted Diff | Diff
Patch V2 (16.82 KB, patch)
2013-05-17 10:45 PST, Frédéric Wang
no flags Review Patch | Details | Formatted Diff | Diff
Patch V3 (26.38 KB, patch)
2013-05-18 07:31 PST, Frédéric Wang
eflews.bot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Patch V4 (31.24 KB, patch)
2013-05-18 08:17 PST, Frédéric Wang
buildbot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Patch V5 (34.90 KB, patch)
2013-05-18 12:25 PST, Frédéric Wang
eflews.bot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Patch V5 - bis (34.90 KB, patch)
2013-05-21 00:36 PST, Frédéric Wang
eflews.bot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Patch V5 - try to build again (37.69 KB, patch)
2013-05-22 12:34 PST, Frédéric Wang
buildbot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Patch V5 - ter (37.90 KB, patch)
2013-06-04 15:08 PST, Frédéric Wang
buildbot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Patch V5 - quater (39.93 KB, patch)
2013-06-05 00:17 PST, Frédéric Wang
cfleizach: review-
Review Patch | Details | Formatted Diff | Diff
Patch V6 (30.06 KB, patch)
2013-06-26 09:56 PST, Frédéric Wang
eflews.bot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Patch V7 (30.74 KB, patch)
2013-06-28 10:13 PST, Frédéric Wang
no flags Review Patch | Details | Formatted Diff | Diff
Patch V8 (30.75 KB, patch)
2013-06-28 12:33 PST, Frédéric Wang
cfleizach: review+
buildbot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Archive of layout-test-results from webkit-ews-01 for mac-mountainlion (666.58 KB, application/zip)
2013-06-28 13:43 PST, Build Bot
no flags Details
Patch V9 (31.18 KB, patch)
2013-06-28 13:59 PST, Frédéric Wang
buildbot: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Archive of layout-test-results from webkit-ews-15 for mac-mountainlion-wk2 (480.37 KB, application/zip)
2013-06-28 15:50 PST, Build Bot
no flags Details
Archive of layout-test-results from webkit-ews-08 for mac-mountainlion (657.29 KB, application/zip)
2013-06-28 20:12 PST, Build Bot
no flags Details
Patch V10 (31.18 KB, patch)
2013-06-28 23:30 PST, Frédéric Wang
cfleizach: review+
commit-queue: commit‑queue-
Review Patch | Details | Formatted Diff | Diff
Patch Final Version (31.14 KB, patch)
2013-06-30 02:08 PST, Frédéric Wang
no flags Review Patch | Details | Formatted Diff | Diff


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2013-05-05 01:23:54 PST
I thought this was already supported and didn't report it before, but according to

https://trac.webkit.org/wiki/MathML%20Status

that's not the case. Supporting at least width/height/depth would be useful to help MathML generators to tweak the spacing of formulas. MathJax also uses negative spacing (negative width).

Here is a convenient dynamic test:

https://www.mozilla.org/projects/mathml/demo/mspace.html
------- Comment #1 From 2013-05-06 06:57:44 PST -------
Just FYI, I started to work on this today. It looks like a parsing function like

http://mxr.mozilla.org/mozilla-central/source/content/mathml/content/src/nsMathMLElement.cpp#310

will be necessary. This is already needed for mfrac.
------- Comment #2 From 2013-05-16 15:02:57 PST -------
Created an attachment (id=201993) [details]
WIP Patch

Experimental support for the mspace element.

I guess negative spacing will not be considered in this bug, as that will require special layout of elements not available in CSS.

Currently, there are hard coded default values width=30px, height=10px and depth=20px but it's just to verify that the patch works correctly. As said in comment 1, a parsing function is necessary for MathML length (similar to CSS values, but with some differences):

http://www.w3.org/TR/MathML/chapter2.html#type.length

I'm not familiar with WebKit String manipulation or Style structures, so I'll need some help to implement such a parsing function properly.
------- Comment #3 From 2013-05-17 10:45:38 PST -------
Created an attachment (id=202118) [details]
Patch V2

OK, I added a parsing function for MathML Length, similar to the one in Gecko and I used that to parse the mspace attributes (and mfrac@linethickness). For the moment, unitless, % and px values should work, but I'm still not quite sure about how to handle the other CSS units.

@Martin: Any idea about how to convert the other CSS units to pixels? I tried things with style()->fontMetrics().xHeight(), style()->font().spaceWidth() or even style()->fontMetrics().unitsPerEm(), but that does not seem to work very well. There are probably functions in Webkit to do that conversion?
------- Comment #4 From 2013-05-18 06:17:16 PST -------
> @Martin: Any idea about how to convert the other CSS units to pixels?

Never mind, I think I figured it out. I'll come back when I have tests.
------- Comment #5 From 2013-05-18 07:31:18 PST -------
Created an attachment (id=202203) [details]
Patch V3

Additional note: I did as in Gecko and provided separate ParseNumericValue and ParseNamedSpaceValue functions. IIRC, mpadded attribute parsing is a bit different and it was convenient to have separate functions.
------- Comment #6 From 2013-05-18 07:36:32 PST -------
(From update of attachment 202203 [details])
Attachment 202203 [details] did not pass efl-wk2-ews (efl-wk2):
Output: http://webkit-queues.appspot.com/results/498295
------- Comment #7 From 2013-05-18 07:37:15 PST -------
(From update of attachment 202203 [details])
Attachment 202203 [details] did not pass efl-ews (efl):
Output: http://webkit-queues.appspot.com/results/491715
------- Comment #8 From 2013-05-18 07:48:11 PST -------
Oops, I think I forgot to edit Source/WebCore/WebCore.vcproj/WebCore.vcproj...
------- Comment #9 From 2013-05-18 07:51:25 PST -------
(From update of attachment 202203 [details])
Attachment 202203 [details] did not pass win-ews (win):
Output: http://webkit-queues.appspot.com/results/493650
------- Comment #10 From 2013-05-18 07:55:26 PST -------
(From update of attachment 202203 [details])
Attachment 202203 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/495679
------- Comment #11 From 2013-05-18 08:08:35 PST -------
(From update of attachment 202203 [details])
Attachment 202203 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/494688
------- Comment #12 From 2013-05-18 08:17:59 PST -------
Created an attachment (id=202204) [details]
Patch V4
------- Comment #13 From 2013-05-18 08:20:53 PST -------
(From update of attachment 202204 [details])
Attachment 202204 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/497395
------- Comment #14 From 2013-05-18 08:22:43 PST -------
(From update of attachment 202204 [details])
Attachment 202204 [details] did not pass efl-wk2-ews (efl-wk2):
Output: http://webkit-queues.appspot.com/results/490748
------- Comment #15 From 2013-05-18 08:23:56 PST -------
(From update of attachment 202204 [details])
Attachment 202204 [details] did not pass efl-ews (efl):
Output: http://webkit-queues.appspot.com/results/494693
------- Comment #16 From 2013-05-18 08:43:14 PST -------
(From update of attachment 202204 [details])
Attachment 202204 [details] did not pass win-ews (win):
Output: http://webkit-queues.appspot.com/results/493661
------- Comment #17 From 2013-05-18 08:52:38 PST -------
(From update of attachment 202204 [details])
Attachment 202204 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/495684
------- Comment #18 From 2013-05-18 12:25:22 PST -------
Created an attachment (id=202212) [details]
Patch V5
------- Comment #19 From 2013-05-18 12:31:26 PST -------
(From update of attachment 202212 [details])
Attachment 202212 [details] did not pass efl-wk2-ews (efl-wk2):
Output: http://webkit-queues.appspot.com/results/492774
------- Comment #20 From 2013-05-18 12:31:34 PST -------
(From update of attachment 202212 [details])
Attachment 202212 [details] did not pass efl-ews (efl):
Output: http://webkit-queues.appspot.com/results/500257
------- Comment #21 From 2013-05-18 12:44:39 PST -------
(From update of attachment 202212 [details])
Attachment 202212 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/493719
------- Comment #22 From 2013-05-18 12:55:38 PST -------
(From update of attachment 202212 [details])
Attachment 202212 [details] did not pass win-ews (win):
Output: http://webkit-queues.appspot.com/results/488885
------- Comment #23 From 2013-05-18 13:02:31 PST -------
(From update of attachment 202212 [details])
Attachment 202212 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/493720
------- Comment #24 From 2013-05-21 00:36:04 PST -------
Created an attachment (id=202388) [details]
Patch V5 - bis
------- Comment #25 From 2013-05-21 00:41:02 PST -------
(From update of attachment 202388 [details])
Attachment 202388 [details] did not pass efl-ews (efl):
Output: http://webkit-queues.appspot.com/results/422172
------- Comment #26 From 2013-05-21 00:42:05 PST -------
(From update of attachment 202388 [details])
Attachment 202388 [details] did not pass efl-wk2-ews (efl-wk2):
Output: http://webkit-queues.appspot.com/results/524141
------- Comment #27 From 2013-05-21 01:01:35 PST -------
(From update of attachment 202388 [details])
Attachment 202388 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/527099
------- Comment #28 From 2013-05-21 01:02:51 PST -------
(From update of attachment 202388 [details])
Attachment 202388 [details] did not pass win-ews (win):
Output: http://webkit-queues.appspot.com/results/525126
------- Comment #29 From 2013-05-21 01:16:19 PST -------
(From update of attachment 202388 [details])
Attachment 202388 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/498686
------- Comment #30 From 2013-05-22 12:34:23 PST -------
Created an attachment (id=202612) [details]
Patch V5 - try to build again
------- Comment #31 From 2013-05-22 12:44:09 PST -------
(From update of attachment 202612 [details])
Attachment 202612 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/582001
------- Comment #32 From 2013-05-22 12:51:35 PST -------
(From update of attachment 202612 [details])
Attachment 202612 [details] did not pass win-ews (win):
Output: http://webkit-queues.appspot.com/results/559009
------- Comment #33 From 2013-05-22 13:00:01 PST -------
(From update of attachment 202612 [details])
Attachment 202612 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/579001
------- Comment #34 From 2013-05-23 11:30:14 PST -------
So it seems the latest version builds on everything but Mac/Windows. Martin, can you please try to edit the XCode files with your Mac?

--

Dave just mentioned the following code in mathml.css

mspace[linebreak="newline"] {
  display: block;
}

that used to be used to create a newline but no longer works with the flex boxes. So that can be removed (the attribute is deprecated in MathML BTW ; line breaking is done on mo operators in MathML3)
------- Comment #35 From 2013-06-04 14:11:59 PST -------
Here's the error on Windows: 7>WebCore.lib(MathMLAllInOne.obj) : error LNK2019: unresolved external symbol "public: __thiscall WebCore::RenderMathMLSpace::RenderMathMLSpace(class WebCore::Element *)" (??0RenderMathMLSpace@WebCore@@QAE@PAVElement@1@@Z) referenced in function "private: virtual class WebCore::RenderObject * __thiscall WebCore::MathMLTextElement::createRenderer(class WebCore::RenderArena *,class WebCore::RenderStyle *)" (?createRenderer@MathMLTextElement@WebCore@@EAEPAVRenderObject@2@PAVRenderArena@2@PAVRenderStyle@2@@Z)
7>C:\cygwin\home\buildbot\WebKit\WebKitBuild\Release\bin\WebKit.dll : fatal error LNK1120: 1 unresolved externals

Perhaps you need to add the new file to the MathMLAllInOne.cpp file?
------- Comment #36 From 2013-06-04 14:12:40 PST -------
It seems you also removed something that looks like a BOM from the beginning of the file. I'm not sure if that's important or not...
------- Comment #37 From 2013-06-04 14:17:05 PST -------
I cannot see anything immediately wrong with the additional lines in the XCode file, but you might try running xcodebodge and see if it produces something noticeably different: http://svn.jacekowski.org/chromium/trunk/tools/xcodebodge/xcodebodge.py
------- Comment #38 From 2013-06-04 15:08:26 PST -------
Created an attachment (id=203729) [details]
Patch V5 - ter

> Perhaps you need to add the new file to the MathMLAllInOne.cpp file?

I doubt this is the problem. The new files are for the mspace element and are in rendering/ while MathMLAllInOne does not contain any reference for other elements (mfrac, mfenced, msqrt etc).

> It seems you also removed something that looks like a BOM from the beginning of the file. I'm not sure if that's important or not...

That could well be the issue. I just refreshed the patch and will try again without this modification. If that does not work I'll try the Python script later.
------- Comment #39 From 2013-06-04 15:34:17 PST -------
(From update of attachment 203729 [details])
Attachment 203729 [details] did not pass win-ews (win):
Output: http://webkit-queues.appspot.com/results/711501
------- Comment #40 From 2013-06-04 15:40:32 PST -------
(From update of attachment 203729 [details])
Attachment 203729 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/673572
------- Comment #41 From 2013-06-04 15:43:10 PST -------
(From update of attachment 203729 [details])
Attachment 203729 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/714560
------- Comment #42 From 2013-06-05 00:17:24 PST -------
Created an attachment (id=203758) [details]
Patch V5 - quater
------- Comment #43 From 2013-06-19 14:00:55 PST -------
(From update of attachment 203758 [details])
View in context: https://bugs.webkit.org/attachment.cgi?id=203758&action=review

You should separate the value parsing from the MathMLSpace patch into two patch I think, so you can address the line thickness issue separately.

Thanks

> LayoutTests/mathml/presentation/mfrac-linethickness-expected-mismatch.html:4
> +    <title>mfrac linethickness</title>

what is this testing? there's nothing related to mfrac in here

> LayoutTests/mathml/presentation/mspace-expected.html:1
> +<!DOCTYPE html>

Your layout tests probably shouldn't be suffixed with -expected, because that's the suffix for the expected results.

I also don't see any results from running these layout tests...

> Source/WebCore/WebCore.vcxproj/WebCore.vcxproj:-1
> -<?xml version="1.0" encoding="utf-8"?>

inccorrect addition here?

> Source/WebCore/rendering/mathml/RenderMathMLBlock.cpp:317
> +    return false;

It seems a shame this is specific to MathML and not re-usable. I see code in CSSPrimitiveValue that handles some of these cases it appears

> Source/WebCore/rendering/mathml/RenderMathMLBlock.cpp:322
> +    int i = 0;

you should choose a better name for this variable, plus it looks like it should be a float anyway
------- Comment #44 From 2013-06-19 14:21:42 PST -------
(In reply to comment #43)
> You should separate the value parsing from the MathMLSpace patch into two patch I think, so you can address the line thickness issue separately.

Yes that's probably what I'll do once MathJax 2.3 (hopefully this summer) is released and I can work on WebKit MathML again. Thanks for the review!

> 
> Thanks
> 
> > LayoutTests/mathml/presentation/mfrac-linethickness-expected-mismatch.html:4
> > +    <title>mfrac linethickness</title>
> 
> what is this testing? there's nothing related to mfrac in here

This is a != reftest as indicated by the "expected-mismatch" suffix. The explanation is in the corresponding test LayoutTests/mathml/presentation/mfrac-linethickness.html

> 
> > LayoutTests/mathml/presentation/mspace-expected.html:1
> > +<!DOCTYPE html>
> 
> Your layout tests probably shouldn't be suffixed with -expected, because that's the suffix for the expected results.

Not sure what you mean... That's a == reftest to compare with LayoutTests/mathml/presentation/mspace.html so the -expected suffix is necessary?

> 
> I also don't see any results from running these layout tests...
> 
> > Source/WebCore/WebCore.vcxproj/WebCore.vcxproj:-1
> > -<?xml version="1.0" encoding="utf-8"?>
> 
> inccorrect addition here?

Ooops, I thought I had fixed that one.

> 
> > Source/WebCore/rendering/mathml/RenderMathMLBlock.cpp:317
> > +    return false;
> 
> It seems a shame this is specific to MathML and not re-usable. I see code in CSSPrimitiveValue that handles some of these cases it appears

That's what I asked above but couldn't find these CSS primitive alone. However some work is needed to parse the MathML-specific stuff like the unitless case you implemented, so a separate function is necessary anyway. Note that using a MathML-specific routine is also what Gecko does.

> 
> > Source/WebCore/rendering/mathml/RenderMathMLBlock.cpp:322
> > +    int i = 0;
> 
> you should choose a better name for this variable, plus it looks like it should be a float anyway

True. (I just copied that from the Gecko code...)
------- Comment #45 From 2013-06-19 14:26:29 PST -------
Just to be sure we agree, here is the document I read about WebKit convention regarding reftests: http://trac.webkit.org/wiki/Writing%20Reftests
------- Comment #46 From 2013-06-26 09:56:25 PST -------
Created an attachment (id=205506) [details]
Patch V6
------- Comment #47 From 2013-06-26 10:02:49 PST -------
(From update of attachment 205506 [details])
Attachment 205506 [details] did not pass efl-ews (efl):
Output: http://webkit-queues.appspot.com/results/967343
------- Comment #48 From 2013-06-26 10:03:29 PST -------
(From update of attachment 205506 [details])
Attachment 205506 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/916719
------- Comment #49 From 2013-06-26 10:03:42 PST -------
(From update of attachment 205506 [details])
Attachment 205506 [details] did not pass efl-wk2-ews (efl-wk2):
Output: http://webkit-queues.appspot.com/results/919270
------- Comment #50 From 2013-06-26 10:04:00 PST -------
(From update of attachment 205506 [details])
Attachment 205506 [details] did not pass gtk-ews (gtk):
Output: http://webkit-queues.appspot.com/results/946382
------- Comment #51 From 2013-06-26 10:21:15 PST -------
(From update of attachment 205506 [details])
Attachment 205506 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/978824
------- Comment #52 From 2013-06-26 14:16:51 PST -------
(From update of attachment 205506 [details])
Attachment 205506 [details] did not pass win-ews (win):
Output: http://webkit-queues.appspot.com/results/901226
------- Comment #53 From 2013-06-28 10:13:31 PST -------
Created an attachment (id=205723) [details]
Patch V7

Some remarks:

- Dynamically changes via Javascript does not seem to work. That seems to be a general issue in WebKit MathML (e.g. with linethickness), so that should better be fixed in a separate bug.

- The parsing of pt and pc was broken when I replaced float constants by integers in the MathML length patch. This is fixed and tested here.

- I had hard time to edit the XCode make file by hand and finally tried a Python script suggested by Martin. However, the changes do not seem really consistent with the existing source code so I'd appreciate if someone with a Mac can edit that file with XCode.
------- Comment #54 From 2013-06-28 10:58:44 PST -------
(From update of attachment 205723 [details])
View in context: https://bugs.webkit.org/attachment.cgi?id=205723&action=review

> Source/WebCore/rendering/mathml/RenderMathMLBlock.cpp:299
> +        lengthValue = 4 * floatValue / 3;

use parenthesis to make it clear what the order of operations are

> Source/WebCore/rendering/mathml/RenderMathMLSpace.cpp:30
> +#include "RenderMathMLSpace.h"

this should go right below config

> Source/WebCore/rendering/mathml/RenderMathMLSpace.cpp:48
> +bool RenderMathMLSpace::isChildAllowed(RenderObject*, RenderStyle*) const

this can be put in the header

> Source/WebCore/rendering/mathml/RenderMathMLSpace.cpp:57
> +    m_maxPreferredLogicalWidth = m_minPreferredLogicalWidth = m_width;

don't do cascading equals. put on separate line

> Source/WebCore/rendering/mathml/RenderMathMLSpace.cpp:67
> +    m_width = m_height = m_depth = 0;

ditto about equals

> Source/WebCore/rendering/mathml/RenderMathMLSpace.cpp:73
> +    if (m_width <= 0)

this should just be m_width < 0

> Source/WebCore/rendering/mathml/RenderMathMLSpace.cpp:77
> +    if (m_height + m_depth <= 0)

< 0 instead of <= 0. I would also add parens

> Source/WebCore/rendering/mathml/RenderMathMLSpace.cpp:78
> +        m_height = m_depth = 0;

ditto about the equals

> Source/WebCore/rendering/mathml/RenderMathMLSpace.h:37
> +    RenderMathMLSpace(Element*);

explicit needed before the constructor

> Source/WebCore/rendering/mathml/RenderMathMLSpace.h:43
> +    virtual void updateFromElement();

are these also OVERRIDES?

can all these virtual methods move into private space
------- Comment #55 From 2013-06-28 12:33:19 PST -------
Created an attachment (id=205733) [details]
Patch V8
------- Comment #56 From 2013-06-28 13:43:38 PST -------
(From update of attachment 205733 [details])
Attachment 205733 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/987486

New failing tests:
mathml/presentation/mspace-units.html
------- Comment #57 From 2013-06-28 13:43:44 PST -------
Created an attachment (id=205740) [details]
Archive of layout-test-results from webkit-ews-01 for mac-mountainlion

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: webkit-ews-01  Port: mac-mountainlion  Platform: Mac OS X 10.8.3
------- Comment #58 From 2013-06-28 13:59:38 PST -------
Created an attachment (id=205741) [details]
Patch V9

It seems that there is a small pixel failure in Mac due to rounding errors. Trying again with a modified length computation.
------- Comment #59 From 2013-06-28 15:50:22 PST -------
(From update of attachment 205741 [details])
Attachment 205741 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/981846

New failing tests:
mathml/presentation/mspace-units.html
------- Comment #60 From 2013-06-28 15:50:27 PST -------
Created an attachment (id=205751) [details]
Archive of layout-test-results from webkit-ews-15 for mac-mountainlion-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: webkit-ews-15  Port: mac-mountainlion-wk2  Platform: Mac OS X 10.8.3
------- Comment #61 From 2013-06-28 20:12:45 PST -------
(From update of attachment 205741 [details])
Attachment 205741 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/913443

New failing tests:
mathml/presentation/mspace-units.html
svg/batik/filters/feTile.svg
------- Comment #62 From 2013-06-28 20:12:53 PST -------
Created an attachment (id=205762) [details]
Archive of layout-test-results from webkit-ews-08 for mac-mountainlion

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: webkit-ews-08  Port: mac-mountainlion  Platform: Mac OS X 10.8.3
------- Comment #63 From 2013-06-28 23:30:30 PST -------
Created an attachment (id=205764) [details]
Patch V10
------- Comment #64 From 2013-06-30 01:14:53 PST -------
(From update of attachment 205764 [details])
Rejecting attachment 205764 [details] from commit-queue.

Failed to run "['/Volumes/Data/EWS/WebKit/Tools/Scripts/webkit-patch', '--status-host=webkit-queues.appspot.com', '--bot-id=webkit-cq-02', 'validate-changelog', '--check-oops', '--non-interactive', 205764, '--port=mac']" exit_code: 1 cwd: /Volumes/Data/EWS/WebKit

ChangeLog entry in LayoutTests/ChangeLog contains OOPS!.

Full output: http://webkit-queues.appspot.com/results/860684
------- Comment #65 From 2013-06-30 02:08:18 PST -------
Created an attachment (id=205774) [details]
Patch Final Version
------- Comment #66 From 2013-06-30 03:09:05 PST -------
(From update of attachment 205774 [details])
Rejecting attachment 205774 [details] from commit-queue.

Failed to run "['/Volumes/Data/EWS/WebKit/Tools/Scripts/webkit-patch', '--status-host=webkit-queues.appspot.com', '--bot-id=webkit-cq-03', 'land-attachment', '--force-clean', '--non-interactive', '--parent-command=commit-queue', 205774, '--port=mac']" exit_code: 1 cwd: /Volumes/Data/EWS/WebKit

Last 500 characters of output:
ubmit
    return self.open(self.click(*args, **kwds))
  File "/Volumes/Data/EWS/WebKit/Tools/Scripts/webkitpy/thirdparty/autoinstalled/mechanize/_mechanize.py", line 203, in open
    return self._mech_open(url, data, timeout=timeout)
  File "/Volumes/Data/EWS/WebKit/Tools/Scripts/webkitpy/thirdparty/autoinstalled/mechanize/_mechanize.py", line 255, in _mech_open
    raise response
webkitpy.thirdparty.autoinstalled.mechanize._response.httperror_seek_wrapper: HTTP Error 500: Internal Server Error

Full output: http://webkit-queues.appspot.com/results/887325
------- Comment #67 From 2013-07-01 11:20:03 PST -------
(From update of attachment 205774 [details])
Not sure why the commit failed. Apparently everything is green, so that seemed to be an infrastructure problem.
------- Comment #68 From 2013-07-01 11:42:21 PST -------
(From update of attachment 205774 [details])
Clearing flags on attachment: 205774

Committed r152235: <http://trac.webkit.org/changeset/152235>
------- Comment #69 From 2013-07-01 11:42:29 PST -------
All reviewed patches have been landed.  Closing bug.
------- Comment #70 From 2013-07-02 05:49:56 PST -------
This caused some failures on debug bots: https://bugs.webkit.org/show_bug.cgi?id=118298
------- Comment #71 From 2014-01-14 12:33:24 PST -------
Testing bugzilla reopen functionality, sorry for the noise.
------- Comment #72 From 2014-03-10 12:25:56 PST -------
Mass change: add WebExposed keyword to help MDN documentation.